Format:

<string in about requester> = <version string(s)>
  - <List of changes>

MakeCD V3.0 = MakeCD 3.22 (19.12.97)
              makecdromfs.module V10.2 (20-12-1997)
              ReadWrite.module 11.23 (07.01.98)
              
              CDR_JVC_Teac.driver 10.24 (20.12.97)
              CDR_MMC_ATAPI.driver 10.24 (20.12.97)
              CDR_Panasonic.driver 10.24 (20.12.97)
              CDR_Philips_2000.driver 10.24 (20.12.97)
              CDR_Philips_2600.driver 10.24 (20.12.97)
              CDR_Plextor_Ricoh.driver 10.24 (20.12.97)
              CDR_Ricoh_6200.driver 10.24 (20.12.97)
              CDR_Sony.driver 10.24 (20.12.97)
              CDR_Yamaha_10x.driver 10.24 (20.12.97)
              CD_ATAPI.driver 10.24 (20.12.97)
              CD_NEC.driver 10.24 (20.12.97)
              CD_Plextor.driver 10.24 (20.12.97)
              CD_ROM.driver 10.24 (20.12.97)
              CD_Sony.driver 10.24 (20.12.97)
              CD_Toshiba.driver 10.24 (20.12.97)

 - disc-at-once
 - indices (not always possible in track-at-once)
 - rewrote and enhanced GUI
 - renamed SCSI drivers
 - new settings
 - AHI support
 - Formating a CD-RW is much more flexible now: can delete session only,
   remove fixation, ...
 - ISO image creation: a file with a list of filenames can be used to
   specify files that are included in the image
 - MS-DOS boot options: MakeCD can create ISO images for CD-Rs booting MS-DOS
   on a PC now.
 - JVC/Teac driver: mode 2 writing (without form) might work now
 - CD_ATAPI.driver: Some drives incorrectly reported "wrong track type" errors
   when reading CDDA.
 - Bugfix: Left and right audio channel should no longer be swapped when
   using Amiga audio.
 - Bugfix: User aborts were ignored during writing if the IO error handling
   was set to "Ignore" or "Pad".


MakeCD V3.1: MakeCD 3.27 (23.01.98)
             makecdromfs.module V10.2 (20-12-1997)
             ReadWrite.module 12.26 (23.01.98)

             CDR_JVC_Teac.driver 11.31 (23.01.98)
             CDR_Panasonic.driver 11.31 (23.01.98)
             CDR_Philips_2000.driver 11.31 (23.01.98)
             CDR_Philips_2600.driver 11.31 (23.01.98)
             CDR_Plextor_Ricoh.driver 11.31 (23.01.98)
             CDR_Ricoh_6200.driver 11.31 (23.01.98)
             CDR_SCSI3_ATAPI.driver 11.31 (23.01.98)
             CDR_Sony.driver 11.31 (23.01.98)
             CDR_Yamaha_10x.driver 11.31 (23.01.98)
             CD_ATAPI.driver 11.31 (23.01.98)
             CD_NEC.driver 11.31 (23.01.98)
             CD_Plextor.driver 11.31 (23.01.98)
             CD_ROM.driver 11.31 (23.01.98)
             CD_Sony.driver 11.31 (23.01.98)
             CD_Toshiba.driver 11.31 (23.01.98)

 ***************** SCSI and IO changes **********************
 - Read speed can be reduced for data tracks, too.
 - slightly improved generic SCSI handling
 - SCSI driver now choose supported write command automatically. This
   makes writing with Panasonic 7502 and HP 7500+ possible.
 - recognize more drives
 - MMC driver supports Panasonic/Matsushita 7502 now. However,
   this drive has several problems (at least with firmware V3.02 -
   V3.05 is available, but untested):
   * It often forgets the correct contents of the CD-R. E.g. "Update"
     after writing and fixation in test mode makes it forget the
     fixation, but not the tracks. Reinsert the CD-R in such a case.
     This prevents "write after test" writing.
   * It sometimes reads wrong track types from a CD-R (e.g. mode 2 
     instead of audio).
   * ISRCs in DAO don't work at the moment. Make sure your projects
     don't contain any, otherwise you will get an "Illegal field in
     command descriptor error". This might be fixed soon.
   * In DAO mixed CDs have to be copied with raw data. The drive
     cannot handle the different block sizes MakeCD uses. If you try
     to use cooked data you might get a "buffer underrun" between data
     and audio tracks. V3.1 will select raw data if you instruct MakeCD
     to choose automatically by using data mode "writer".
   * Mode 2, form 1 does not work in TAO.
   * In TAO gaps between tracks of different types are too short.
 - Bugfix: TOC type was chosen incorrectly for DAO if raw data was written,
   resulting in wrong medium type and not working PSX copies. This also
   caused Philips/Ricoh/Plextor writers to report a wrong mode for the
   mode 2 data track.
 - Bugfix: although none given, Philips/Ricoh wrote medium catalog number 
   both in TAO  and DAO. This made PSX copies unusable in a PlayStation.
 - Bugfix: data encoding for CDR_Plextor_Ricoh.driver was wrong, resulting
   in trashed DAO CD-Rs.
 - Bugfix (Philips, Plextor): didn't work with all controllers
 - Bugfix: removing the source CD while MakeCD was preparing for
   index scanning trapped MakeCD in a loop until the CD was inserted
   again.
 - Bugfix: CDR_Sony.driver couldn't write audio tracks.
 - SCSI error detection failed for JVC/Teac drives when connected to some
   controllers. This prevented writing to empty CD-Rs.
 - Yamaha CDR10x couldn't always write all tracks with
   cybppc.device V44.2, because this device doesn't report
   some essential sense codes. Enhanced workaround.
 - Bugfix: priority of conversion process was not always increased
 - Bugfix: MMC driver still knew Ricoh MP6200S.
 - MMC/ATAPI: support for writing mode 2 with block size 2332; enabled
   only for Sony 928E, because mode 2 with 2336 didn't work there. Not
   tested completely with Sony 928E yet.
   If only mode 2 writing fails for a MMC/ATAPI writer than this optional
   mode is not implemented. For known drives like the Sony 928E MakeCD selects
   a substitute automatically, but not generally, because PSX copies might
   be less compatible in this mode. You can enforce this workaround by
   setting a environment variable with "setenv MAKECD_MODE2_MIXED". If it
   works only this way, please tell Patrick.
 - MMC/ATAPI: $30 and $C are recognizes as buffer underruns, too.
 - Bugfix: CDs with two consecutive data tracks of the same type were
   not copied properly (e.g. video CDs).
 - Bugfix: Adding pause blocks to a ISO image that was written online was not
   possible.
 - MakeCD now adds some blocks to a created ISO image to compensate for read
   errors that might occur at the end (but never did so far - only the
   new Panasonic 7502 might trash the last two blocks).
 - Renamed CDR_MMC_ATAPI.driver to CDR_SCSI3_ATAPI.driver because of the
   confusion caused by the "ATAPI" in the name. ATAPI and MMC (Multi Media
   Command set defined by SCSI 3) are so similar that only ome driver is
   sufficient to cover both.

 ************************* GUI changes ********************************
 - Several QuickHelps were rewritten.
 - ISO image source file requester offers pattern gadgets and shows
   .info by default.
 - MakeCD can execute several user selectable commands on different
   occasions, e.g. to play sounds. If a command is not set, MakeCD
   flashes the screen instead to draw the intention to requesters.
 - MakeCD now indicates more clearly when the write window is idle again.
 - Track option gadgets are disabled if no track exists.
 - Track options window is opened after adding a new track.
 - Bugfix: changing tracks while pausing audio playing is possible now.
 - Bugfix: lock on base dir was not freed if the advanced options
   window was open when exiting the program.
 - Bugfix: Pausing audio playing did not always work properly, and volume
   and filter were reset at the beginning of each new track.
 - Bugfix: "-" could be entered in medium catalog number gadget, although it
   is an illegal character


MakeCD V3.1a: MakeCD 3.33 (12.02.98)
              makecdromfs.module V10.2 (20-12-1997)
              ReadWrite.module 13.28 (12.02.98)
              SCSISupport.module 12.21 (12.02.98)

              CDR_JVC_Teac.driver 12.40 (12.02.98)
              CDR_Panasonic.driver 12.40 (12.02.98)
              CDR_Philips_2000.driver 12.40 (12.02.98)
              CDR_Philips_2600.driver 12.40 (12.02.98)
              CDR_Plextor_Ricoh.driver 12.40 (12.02.98)
              CDR_Ricoh_6200.driver 12.40 (12.02.98)
              CDR_SCSI3_ATAPI.driver 12.40 (12.02.98)
              CDR_Sony.driver 12.40 (12.02.98)
              CDR_Yamaha_10x.driver 12.40 (12.02.98)
              CD_ATAPI.driver 12.40 (12.02.98)
              CD_NEC.driver 12.40 (12.02.98)
              CD_Plextor.driver 12.40 (12.02.98)
              CD_ROM.driver 12.40 (12.02.98)
              CD_Sony.driver 12.40 (12.02.98)
              CD_Toshiba.driver 12.40 (12.02.98)

 ***************** SCSI and IO changes **********************
 - Bugfix CDR_Yamaha_CDR10x: DAO writing of cooked data + audio was broken.
 - Bugfix CDR_Panasonic: writing of audio was broken and the changed generic
   SCSI handling might have caused a worse performance.
 - Sony 928E: the drive didn't read mode 2 correctly, but with the new raw
   mode 2 reading it works now. Writing of mode 2 + audio now works, too.
 - Panasonic 7502: the tray is opened and closed to make the drive forget
   tracks written in test mode (necessary because just turning off the test
   mode confused this drive). With the Commodore scsi.device writing was
   aborted due to "bad status" errors although writing seemed to work fine.
   This is ignored now, but not completely tested yet.
 - Bugfix Philips CDD522: choosing speeds > 2 was not caught by the driver
   but caused an error requester.
 - Bugfix (SCSI3): ISRCs were written incorrectly in DAO
 - Bugfix: MakeCD might have got the track starts and lengths wrong by a
   factor of 2 or 4 if the source drive didn't use 2048 bytes as default
   block size or was set to this value by some other application.
 - CD_Toshiba.driver couldn't read audio tracks after reading a raw
   data track (it failed already for the first block).
 - improved index scanning to make it more robust
 - added some more drive IDs (see Compatibility.guide in case your drive
   is still not known)
 - Workaround: mode 2 tracks might have been recognized as mode 1 when
   writing in DAO with raw data. The relevant part of the track is okay
   and a PSX copy actually works in a PlayStation nonetheless. The reason
   are probably the missing checksums in the gap before the data track.
 - Workaround for mode 2 reading problems (see "MAKECD_READ_MODE2_RAW"
   below).
 - SCSI3/ATAPI Workaround "MAKECD_MODE2_MIXED" was renamed to
   "MAKECD_WRITE_MODE2_MIXED".
 - Workaround for PPC SCSI and fixation/repair/format problems:
   cybppc.device with version < 44.36 cancels all SCSI commands automatically
   that are not returned by the drive in a certain amount of time. This is
   done to prevent lockups of the SCSI bus, but it also aborted some of
   the commands that are used for CD writing and really go on for a while,
   the most common one probably being fixation. Formating, repair and DAO
   might also be affected.

   MakeCD now applies a workaround for this problem by making the drive return
   the command immediately and querying the drive until it is ready again.
   However, it depends on the drive and on the command whether this is
   possible or not. For fixation this immediate response is only supported by
   SCSI3/ATAPI, Philips, Plextor/Ricoh and Yamaha drives, but not by JVC/Teac,
   Panasonic/Matsushita or Sony drives (unless they use the SCSI3/ATAPI driver).
   It is not supported by any drive for the repair or format commands.

   This workaround is only used for the cybppc.device, because not all
   other controllers would handle this correctly (the dracoscsi.device
   crashes when fixating with a Philips CDD2600 this way).

 ********************* GUI changes **************************
 - CONTEXT SENSITIVE AMIGAGUIDE: Pressing HELP over a gadget opens the
   AmigaGuide documentation at the corresponding node. However, this is not
   possible with the V2.5 English documentation and the new translation is
   not ready yet.
 - MakeCD now allows the frequency of AIFF to be off by upto 10%, because
   not every system is able to produce exactly 44.1kHz. BE WARNED: MakeCD
   does not adapt the frequency, it just assumes it was 44.1kHz. Playing
   a sample with a frequency that is 10% too high or low already sounds
   quite awful!
 - Bugfix: text for publisher field in ISO image was wrong in some cases
 - Bugfix: manually jumping between tracks during audio playing still forgot
   the current settings for low pass filter and volume.
 - Bugfix: updating from final TAO to DAO was not possible with the menu
   item "Projects/Registration..."
 - MakeCD is more intelligent when choosing the best data format if you don't
   override this choice yourself by choosing "raw" or "cooked" explicitely:
   some drives like the Panasonic 7502 (firmeware 3.02) have problems when
   copying CDs with cooked data, so MakeCD uses raw data by default. However,
   if your source is an ISO image than cooked is used as MakeCD couldn't
   convert this to raw.
 - If speed cannot be set, then the speed gadgets are empty now and no longer
   set to the unused value.
 - Fix for problems with saving the settings. This might have failed after
   fixing the icon position of MakeCD if the Workbench protected the
   MakeCD.info from writing.
 - fixed some English texts


MakeCD V3.1a - update 1: CD_Toshiba 12.41 (16.02.98)
 - Bugfix CD_Toshiba: the fix for the "audio after raw" problem made things
   worse. Audio reading now didn't work at all with at least one drive :-(


MakeCD V3.1a - update 2 (available as public beta only):
   ReadWrite.module 13.32 public beta (18.03.98)
   SCSISupport.module 12.22 public beta (18.03.98)

   CDR_JVC_Teac.driver 12.46 public beta (18.03.98)
   CDR_Panasonic.driver 12.46 public beta (18.03.98)
   CDR_Philips_2000.driver 12.46 public beta (18.03.98)
   CDR_Philips_2600.driver 12.46 public beta (18.03.98)
   CDR_Plextor_Ricoh.driver 12.46 public beta (18.03.98)
   CDR_Ricoh_6200.driver 12.46 public beta (18.03.98)
   CDR_SCSI3_ATAPI.driver 12.46 public beta (18.03.98)
   CDR_Sony.driver 12.46 public beta (18.03.98)
   CDR_Yamaha_10x.driver 12.46 public beta (18.03.98)
   CD_ATAPI.driver 12.46 public beta (18.03.98)
   CD_NEC.driver 12.46 public beta (18.03.98)
   CD_Plextor.driver 12.46 public beta (18.03.98)
   CD_ROM.driver 12.46 public beta (18.03.98)
   CD_Sony.driver 12.46 public beta (18.03.98)
   CD_Toshiba.driver 12.46 public beta (18.03.98)

 - Setting speed with SCSI3/ATAPI is more sophisticated now and also
   checks the real speed used by the drive. This method solves problems
   with Plextor PX-426S and 2x with Ricoh MP6200S. Note that the Ricoh
   seems to be unable to write CD-RW in single speed at all.
 - Added raw encoding: now cooked data can be written to drives only
   supporting raw data in DAO, e.g. an ISO image can be written in DAO
   to a CDD2600.
   However, this conversion demands very much computing power and is even
   on a 060 hardly fast enough to keep up with 4x. The GUI definetely has
   to be changed to warn of that, and as this is not implemented yet the
   encoding feature is still disabled by default. It has to be enabled
   by setting the environment variable MAKECD_ALLOW_ENCODING.
 - The problem with reading the first blocks of a raw DAO copy in some drives
   should be fixed now.
 - Added some drive IDs and disabled session fixation in DAO for Ricoh 1420/
   Plextor PX-24C because these drives don't support that.
 - According to the Pioneer documentation modern Pioneer drives (like DR-U12X
   and DR-U24X) don't support speed selection at all, therefore they are now
   only recognised by the CD_Sony.driver, which doesn't set speed.
 - DAO was disabled for the HP 7100+ because firmware 1.x didn't implement
   it. However, we have been told that it was added with firmware 2.x to
   the HP 7100+ and the similar Philips CDD3610. DAO is now allowed by
   MakeCD again, but it hasn't been tested with either of these drives yet.
 - DAO is disabled for some drives that haven't implemented it. This avoids
   SCSI errors when trying to use it with such drives. However, for tests
   with newer firmware versions DAO can be enabled again by setting the
   environment variable MAKECD_ALLOW_DAO.
 - The priority of read, write and conversion process is increased when doing
   critical work. The default priority is 6, because the console.device is
   doing CPU consuming work at priority 5. These defaults can be changed by
   setting the environment variables MAKECD_INC_PRI_[READ|WRITE|CONV], but
   usually there should be no need to do that.
 - Invalid status errors that are reported by the combination A3000 SCSI +
   Panasonic 7502 are finally ignored properly, so data (= mode 1) works now.
   Audio never caused this invalid status errors. However, mode 2 is not
   working because the SCSI bus locks completely.
 - CD_ATAPI can (and should) be used to read CDs with the Sony 928E.
 - No CD_ driver tries to read session infos any more - this was not used
   for the source drive and sometimes seemed to have caused problems.
 - Automatic "IO Error" handling didn't work properly. Now the real errors
   are always reported, too. Write errors are no longer ignored automatically.
   However, for read errors that lead to an automatic abort the text still
   says "User abort".
 - Bugfix: potential memory trashing with the READ_MODE2_RAW workaround.
 - Bugfix: using delete mode "immediately" with DAO caused an internal error.
 - "Write after test" didn't work properly with drives using the open/close
   tray method (Panasonic 7502).
 - Bugfix: under a certain timing the amount of filled bytes in the
   MakeCD buffer could have been displayed as a large number and 100%.
 - Bugfix: SCSI errors were ignored after one command (only happened with
   Plextor PX-624C in one case).


MakeCD V3.1b - MakeCD 3.33 (12.02.98)
               makecdromfs.module V10.2 (20-12-1997)
               ReadWrite.module 13.33 (08.04.98)
               SCSISupport.module 12.22 (08.04.98)

               CDR_JVC_Teac.driver 12.47 (08.04.98)
               CDR_Panasonic.driver 12.47 (08.04.98)
               CDR_Philips_2000.driver 12.47 (08.04.98)
               CDR_Philips_2600.driver 12.47 (08.04.98)
               CDR_Plextor_Ricoh.driver 12.47 (08.04.98)
               CDR_Ricoh_6200.driver 12.47 (08.04.98)
               CDR_SCSI3_ATAPI.driver 12.47 (08.04.98)
               CDR_Sony.driver 12.47 (08.04.98)
               CDR_Yamaha_10x.driver 12.47 (08.04.98)
               CD_ATAPI.driver 12.47 (08.04.98)
               CD_NEC.driver 12.47 (08.04.98)
               CD_Plextor.driver 12.47 (08.04.98)
               CD_ROM.driver 12.47 (08.04.98)
               CD_Sony.driver 12.47 (08.04.98)
               CD_Toshiba.driver 12.47 (08.04.98)

 all changes from public beta above and:
 - Bugfix: converting from raw to cooked data could cause memory trashing.
 - Added fallback in mode 2 recognition to raw block reading => mode 2
   should be recognized by some more drives.
 - Allowed CD_Plextor.driver for Pioneer drives again, because at least
   one user was able to set the speed with his DR-U12X (firmware 1.06
   1996/10/), although the documentation said that this drive always reads
   at maximum speed.
 - Teac 56S is no longer fixed to CD_ATAPI.driver, because audio reading
   didn't always work.
 

Known problems:
 - After closing the write window MakeCD hangs on some systems with a busy
   pointer. This is caused by the filesystem that MakeCD locked to get
   exclusive access to the hardware. Don't mount filesystems on your writer 
   or unmount them before using MakeCD.
 - MakeCD sends redundant commands to work around timing problems with some
   hardware combinations. This additional load seems to cause SCSI problems
   with some other hardware (e.g. Fastlane). If you have SCSI problems then
   use "setenv MAKECD_SIMPLE_SCSI_IO=1" to avoid redundant commands and
   try again. If this helps, then please report to patrick@core.de.
 - The Sony 928E sometimes returns garbage values when reading the contents
   of a CD with the CD writer specific commands. This doesn't happen when
   the standard commands are used, so the CD_ATAPI driver should be used for
   reading from the Sony 928E.
 - Not a real problem: ATAPI doesn't specify DAO, so probably no ATAPI writer
   supports it. But as we are not sure, we haven't disabled DAO in the
   driver for all ATAPI writers unless someone has tested it. If yours fails
   with the error "MODE_SELECT6: Illegal Field in Parameter List" when trying
   to write in DAO, then it doesn't and Patrick would appreciate a short
   notice.
 - workaround for mode 2 (2336 bytes) reading problems:
   Some drives deliver invalid data with this block size (Sony 928E), others
   report checksum errors although they shouldn't use the checksums (Plextor
   PX-20TS). In both cases reading raw data still works, so now MakeCD can
   read mode 2 tracks raw and throws away the unnecessary bytes if necessary.

   This workaround is enabled only for the Sony 928E, but not for any other
   drive, because some drives might read raw data slower and the additional
   processing requires more CPU time. On slow computers with fast drives the
   computer might perhaps even appear to be locked.

   If your drive has similar problems you can enable this workaround by
   creating the environment variable "MAKECD_READ_MODE2_RAW" (e.g. with
   "setenv MAKECD_READ_MODE2_RAW=1"). Please tell Patrick if your drive only
   reads mode 2 properly with this workaround.
 - Panasonic 7501: writing mode 2 fails with an error. As I haven't found a
   way around that mode 2 in spite of several different attempts this will
   stay this way, i.e. writing mode 2 will never be supported by
   CDR_Panasonic.driver.
 - JVC/Teac: copying PSX CDs is not supported yet.
 - Triton has some problems when you keep the cursor keys pressed
   to move within a listview: it might cause MakeCD to open windows.
   It also doesn't calculate the width of the data mode gadget correctly.
 - Ricoh MP6200S (V1.00): doesn't support medium catalog number in DAO,
                          swallows ISRC of first audio track in DAO
 - Yamaha CDR400 (V1.0i): audio scanning gives indices that are too
                          high by two seconds
 - The amount of free blocks is not perfectly correct, because writers
   report different values depending on what was already written. Sometimes
   gaps are included and sometimes not. This causes an inaccuracy of upto
   3 seconds. The end of CD-R check is not affected, though.
 - The Ricoh MP6200S doesn't simulate formating. Therefore MakeCD doesn't
   issue the formating command at if test mode is enabled.
 - Writing audio with preemphasize is not possible with CDR400 (upto V1.0d).
   Yamaha didn't respond to my bug report, so I implemented a fallback
   to normal audio.
 - Yamaha CDR400 sometimes panics after a buffer underrun and doesn't
   stop writing. Yamaha could not help with this problem yet.
 - Ricoh sometimes doesn't read contents properly. Exact reason/solution
   unknown, but turning disconnect off and SCSI bus reset help.
 - dracoscsi.device SCSI direct still doesn't work properly. You must have
   enough free memory in your first memory module or a 32MB module in the
   first socket, otherwise the dracoscsi.device will fail and probably cause
   crashes or read errors. The same rules apply to every other software doing
   SCSI direct.
